#!/usr/bin/python3
# -*- coding: utf-8 -*-

import sys
import time
import json
import random
import ctypes

# ---------------------------------------------------------------------------------

# requirements:
# pip install ctypes

# globals
# https://learn.microsoft.com/en-us/windows/win32/inputdev/virtual-key-codes
# use link from above to add more special keys
SPECIAL_KEYS = {"SPACE": 0x20, "ENTER": 0x0D, "LEFT": 0x25, "UP": 0x26, "RIGHT": 0x27,
                "SHIFT": 0x10, "CTRL": 0x11, "ALT": 0x12, "ESCAPE": 0x1B, "TAB": 0x09,
                "F1": 0x70, "F2": 0x71, "F3": 0x72, "F4": 0x73, "F5": 0x74, "F6": 0x75,
                "F7": 0x76, "F8": 0x77, "F9": 0x78, "F10": 0x79, "F11": 0x7A, "F12": 0x7B}

# ---------------------------------------------------------------------------------

class Config:
    def __init__(self):
        # load the config file
        try:
            configFile = open("config.json", encoding='utf-8-sig')
            config = json.load(configFile)
            configFile.close()
        except IOError:
            print("Could not read config file!")
            sys.exit()
        except json.JSONDecodeError:
            print("config.json: decode error!")
            sys.exit()

        # get values
        self.wait_before_start_seconds = config["wait_before_start_seconds"] # wait before first action
        self.min_random_time_minutes = 60 * config["min_random_time_minutes"] # store in seconds
        self.max_random_time_minutes = 60 * config["max_random_time_minutes"] #  store in seconds
        self.keys = []
        for key in config["random_keys"]:
            self.keys.append(key)

# ---------------------------------------------------------------------------------

class GhostKey:
    def __init__(self):
        self.config = Config()

    def char2key(self, key):
        result = ctypes.windll.User32.VkKeyScanW(ord(key))
        vk_key = result & 0xFF
        return vk_key

    def doRandomKeyPress(self):
        key_index = random.randrange(0, len(self.config.keys))
        key = self.config.keys[key_index]
        if key in SPECIAL_KEYS.keys():
            is_upper = False
            key_vk = SPECIAL_KEYS[key]
        else:
            is_upper = key.isupper()
            key_vk = self.char2key(key)
        if is_upper:
            ctypes.windll.user32.keybd_event(0x10, 0, 0, 0) # shift down
        ctypes.windll.user32.keybd_event(key_vk, 0, 0, 0) # down
        ctypes.windll.user32.keybd_event(key_vk, 0, 0x0002, 0) # up
        if is_upper:
            ctypes.windll.user32.keybd_event(0x10, 0, 0x0002, 0) # shift up

    def doRandomKeyPressInRandomTime(self):
        time.sleep(self.config.wait_before_start_seconds)
        self.doRandomKeyPress()
        wait_seconds = random.randrange(self.config.min_random_time_minutes, self.config.max_random_time_minutes)
        time.sleep(wait_seconds)

    def run(self):
        print("running..")
        try:
            while True:
                self.doRandomKeyPressInRandomTime()
        except KeyboardInterrupt:
            print("canceled by user!")
            sys.exit()

# ---------------------------------------------------------------------------------

if __name__ == "__main__":
    myGhostKey = GhostKey()
    myGhostKey.run()
